<html>
<head>
<title>OgreInstanceBatch.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreInstanceBatch.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreInstanceBatch_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __InstanceBatch_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __InstanceBatch_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderOperation_8h.html">OgreRenderOperation.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderable_8h.html">OgreRenderable.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreMovableObject_8h.html">OgreMovableObject.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreMesh_8h.html">OgreMesh.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre
<a name="l00038"></a>00038 {
<a name="l00087"></a><a class="code" href="classOgre_1_1InstanceBatch.html">00087</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1InstanceBatch.html" title="InstanceBatch forms part of the new Instancing system This is an abstract class that must be derived ...">InstanceBatch</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>
<a name="l00088"></a>00088     {
<a name="l00089"></a>00089     <span class="keyword">public</span>:
<a name="l00090"></a><a class="code" href="group__Scene.html#gaf9139328908d3ca39478897bae89b33a">00090</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;InstancedEntity*&gt;::type</a> <a class="code" href="group__Scene.html#gaf9139328908d3ca39478897bae89b33a">InstancedEntityVec</a>;
<a name="l00091"></a>00091     <span class="keyword">protected</span>:
<a name="l00092"></a><a class="code" href="group__Scene.html#gae262d48aaef74de5069f206c92a14b3e">00092</a>         <a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>     <a class="code" href="group__Scene.html#gae262d48aaef74de5069f206c92a14b3e">mRenderOperation</a>;
<a name="l00093"></a><a class="code" href="group__Scene.html#gacc8cd4d212436db84f8a156779bdb4fe">00093</a>         <span class="keywordtype">size_t</span>              <a class="code" href="group__Scene.html#gacc8cd4d212436db84f8a156779bdb4fe">mInstancesPerBatch</a>;
<a name="l00094"></a>00094 
<a name="l00095"></a><a class="code" href="group__Scene.html#gadd595cecea7604d96ee7beeb8201e948">00095</a>         <a class="code" href="classOgre_1_1InstanceManager.html" title="This is the main starting point for the new instancing system.">InstanceManager</a>     *<a class="code" href="group__Scene.html#gadd595cecea7604d96ee7beeb8201e948" title="Creator of this object (if created by a factory)">mCreator</a>;
<a name="l00096"></a>00096 
<a name="l00097"></a><a class="code" href="group__Scene.html#ga47cd33873c112c7e6be9782a3424e57d">00097</a>         <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>         <a class="code" href="group__Scene.html#ga47cd33873c112c7e6be9782a3424e57d">mMaterial</a>;
<a name="l00098"></a>00098 
<a name="l00099"></a><a class="code" href="group__Scene.html#ga44c764480b55e3b765c13899afd097a9">00099</a>         <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a>              <a class="code" href="group__Scene.html#ga44c764480b55e3b765c13899afd097a9">mMeshReference</a>;
<a name="l00100"></a><a class="code" href="group__Scene.html#ga0ad085e6a80510f87a529d37e0405c32">00100</a>         <a class="code" href="classOgre_1_1Mesh.html#a4ee5e3c78d17a1940ded9419644260ce">Mesh::IndexMap</a> <span class="keyword">const</span> *<a class="code" href="group__Scene.html#ga0ad085e6a80510f87a529d37e0405c32">mIndexToBoneMap</a>;
<a name="l00101"></a>00101 
<a name="l00102"></a>00102         <span class="comment">//InstancedEntities are all allocated at build time and kept as &quot;unused&quot;</span>
<a name="l00103"></a>00103         <span class="comment">//when they&#39;re requested, they&#39;re removed from there when requested,</span>
<a name="l00104"></a>00104         <span class="comment">//and put back again when they&#39;re no longer needed</span>
<a name="l00105"></a>00105         <span class="comment">//Note each InstancedEntity has a unique ID ranging from [0; mInstancesPerBatch)</span>
<a name="l00106"></a><a class="code" href="group__Scene.html#ga1c7fdd24e8039ab7bebb989f7a45478e">00106</a>         <a class="code" href="group__Scene.html#gaf9139328908d3ca39478897bae89b33a">InstancedEntityVec</a>  <a class="code" href="group__Scene.html#ga1c7fdd24e8039ab7bebb989f7a45478e">mInstancedEntities</a>;
<a name="l00107"></a><a class="code" href="group__Scene.html#ga8d00e9d33a377e2495028f34a6384565">00107</a>         <a class="code" href="group__Scene.html#gaf9139328908d3ca39478897bae89b33a">InstancedEntityVec</a>  <a class="code" href="group__Scene.html#ga8d00e9d33a377e2495028f34a6384565">mUnusedEntities</a>;
<a name="l00108"></a>00108 
<a name="l00110"></a><a class="code" href="group__Scene.html#ga0eca285c6128a47ff442f29a08ad5956">00110</a>         <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>      <a class="code" href="group__Scene.html#ga0eca285c6128a47ff442f29a08ad5956" title="This bbox contains all (visible) instanced entities.">mFullBoundingBox</a>;
<a name="l00111"></a><a class="code" href="group__Scene.html#gad91170fb2264f1dc6cf82849e23483d7">00111</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>                <a class="code" href="group__Scene.html#gad91170fb2264f1dc6cf82849e23483d7">mBoundingRadius</a>;
<a name="l00112"></a><a class="code" href="group__Scene.html#gad124fbd681c3359413b6dd4d432dd166">00112</a>         <span class="keywordtype">bool</span>                <a class="code" href="group__Scene.html#gad124fbd681c3359413b6dd4d432dd166">mBoundsDirty</a>;
<a name="l00114"></a><a class="code" href="group__Scene.html#ga83c9a52a7394033552de787c35b4d62c">00114</a>         <span class="keywordtype">bool</span>                <a class="code" href="group__Scene.html#ga83c9a52a7394033552de787c35b4d62c" title="Set to false by derived classes that need it.">mBoundsUpdated</a>;
<a name="l00115"></a><a class="code" href="group__Scene.html#gaf1ed5250bc7561d30121eee637fafefe">00115</a>         <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>              *<a class="code" href="group__Scene.html#gaf1ed5250bc7561d30121eee637fafefe">mCurrentCamera</a>;
<a name="l00116"></a>00116 
<a name="l00117"></a><a class="code" href="group__Scene.html#gaf38e6e1e9048410bdc0bff637f6e1c71">00117</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span>      <a class="code" href="group__Scene.html#gaf38e6e1e9048410bdc0bff637f6e1c71">mMaterialLodIndex</a>;
<a name="l00118"></a>00118 
<a name="l00120"></a><a class="code" href="group__Scene.html#gae5bef3fbc7c84c275be6213dfad385bc">00120</a>         <span class="keywordtype">bool</span>                <a class="code" href="group__Scene.html#gae5bef3fbc7c84c275be6213dfad385bc" title="Set to false at start of each _updateRenderQueue.">mDirtyAnimation</a>;
<a name="l00121"></a>00121 
<a name="l00123"></a><a class="code" href="group__Scene.html#ga5b9bf94e2d0a35eaced57d3b25c4c6e9">00123</a>         <span class="keywordtype">bool</span>                <a class="code" href="group__Scene.html#ga5b9bf94e2d0a35eaced57d3b25c4c6e9" title="False if a technique doesn&#39;t support skeletal animation.">mTechnSupportsSkeletal</a>;
<a name="l00124"></a>00124 
<a name="l00126"></a><a class="code" href="group__Scene.html#ga4f2fece9509142fd33bd0f55dd0cd54e">00126</a>         <span class="keyword">mutable</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="group__Scene.html#ga4f2fece9509142fd33bd0f55dd0cd54e" title="Cached distance to last camera for getSquaredViewDepth.">mCachedCameraDist</a>;
<a name="l00128"></a><a class="code" href="group__Scene.html#gab26ae2f6396e55281865335eb67ab8a5">00128</a>         <span class="keyword">mutable</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a> *<a class="code" href="group__Scene.html#gab26ae2f6396e55281865335eb67ab8a5" title="The camera for which the cached distance is valid.">mCachedCamera</a>;
<a name="l00129"></a>00129 
<a name="l00131"></a><a class="code" href="group__Scene.html#gaf8958033c3eeece3d5d8c4ac2aab4fb6">00131</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#gaf8958033c3eeece3d5d8c4ac2aab4fb6" title="Tells that the list of entity instances with shared transforms has changed.">mTransformSharingDirty</a>;
<a name="l00132"></a>00132 
<a name="l00134"></a><a class="code" href="group__Scene.html#ga962398a3e62a111c018d0d25044364f1">00134</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#ga962398a3e62a111c018d0d25044364f1" title="When true remove the memory of the VertexData we&#39;ve created because no one else will.">mRemoveOwnVertexData</a>;
<a name="l00136"></a><a class="code" href="group__Scene.html#ga4716e9faf7d6c42efeb038dee37f62f4">00136</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#ga4716e9faf7d6c42efeb038dee37f62f4" title="When true remove the memory of the IndexData we&#39;ve created because no one else will.">mRemoveOwnIndexData</a>;
<a name="l00137"></a>00137 
<a name="l00138"></a>00138         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setupVertices( <span class="keyword">const</span> <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* baseSubMesh ) = 0;
<a name="l00139"></a>00139         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setupIndices( <span class="keyword">const</span> <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* baseSubMesh ) = 0;
<a name="l00140"></a>00140         <span class="keyword">virtual</span> <span class="keywordtype">void</span> createAllInstancedEntities(<span class="keywordtype">void</span>);
<a name="l00141"></a>00141         <span class="keyword">virtual</span> <span class="keywordtype">void</span> deleteAllInstancedEntities(<span class="keywordtype">void</span>);
<a name="l00142"></a>00142         <span class="keyword">virtual</span> <span class="keywordtype">void</span> deleteUnusedInstancedEntities(<span class="keywordtype">void</span>);
<a name="l00144"></a>00144         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1InstancedEntity.html">InstancedEntity</a>* generateInstancedEntity(<span class="keywordtype">size_t</span> num);
<a name="l00145"></a>00145 
<a name="l00150"></a>00150         <span class="keywordtype">void</span> makeMatrixCameraRelative3x4( <span class="keywordtype">float</span> *mat3x4, <span class="keywordtype">size_t</span> numFloats );
<a name="l00151"></a>00151 
<a name="l00153"></a>00153         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> checkSubMeshCompatibility( <span class="keyword">const</span> <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* baseSubMesh );
<a name="l00154"></a>00154 
<a name="l00155"></a>00155         <span class="keywordtype">void</span> updateVisibility(<span class="keywordtype">void</span>);
<a name="l00156"></a>00156 
<a name="l00158"></a>00158         <span class="keywordtype">void</span> defragmentBatchNoCull( <a class="code" href="group__Scene.html#gaf9139328908d3ca39478897bae89b33a">InstancedEntityVec</a> &amp;usedEntities );
<a name="l00159"></a>00159 
<a name="l00165"></a>00165         <span class="keywordtype">void</span> defragmentBatchDoCull( <a class="code" href="group__Scene.html#gaf9139328908d3ca39478897bae89b33a">InstancedEntityVec</a> &amp;usedEntities );
<a name="l00166"></a>00166 
<a name="l00167"></a>00167     <span class="keyword">public</span>:
<a name="l00168"></a>00168         <a class="code" href="classOgre_1_1InstanceBatch.html" title="InstanceBatch forms part of the new Instancing system This is an abstract class that must be derived ...">InstanceBatch</a>( <a class="code" href="classOgre_1_1InstanceManager.html" title="This is the main starting point for the new instancing system.">InstanceManager</a> *creator, <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a> &amp;meshReference, <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> &amp;material,
<a name="l00169"></a>00169                         <span class="keywordtype">size_t</span> instancesPerBatch, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Mesh.html#a4ee5e3c78d17a1940ded9419644260ce">Mesh::IndexMap</a> *indexToBoneMap,
<a name="l00170"></a>00170                         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;batchName );
<a name="l00171"></a>00171         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1InstanceBatch.html" title="InstanceBatch forms part of the new Instancing system This is an abstract class that must be derived ...">InstanceBatch</a>();
<a name="l00172"></a>00172 
<a name="l00173"></a><a class="code" href="group__Scene.html#gaf1b34a5640923cb56c47153321cd317a">00173</a>         <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a>&amp; <a class="code" href="group__Scene.html#gaf1b34a5640923cb56c47153321cd317a">_getMeshRef</a>() { <span class="keywordflow">return</span> mMeshReference; }
<a name="l00174"></a>00174 
<a name="l00177"></a>00177         <span class="keywordtype">void</span> _setInstancesPerBatch( <span class="keywordtype">size_t</span> instancesPerBatch );
<a name="l00178"></a>00178 
<a name="l00179"></a><a class="code" href="group__Scene.html#ga244219dff9699f4312faf9b818cdc835">00179</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Mesh.html#a4ee5e3c78d17a1940ded9419644260ce">Mesh::IndexMap</a>* <a class="code" href="group__Scene.html#ga244219dff9699f4312faf9b818cdc835">_getIndexToBoneMap</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mIndexToBoneMap; }
<a name="l00180"></a>00180 
<a name="l00187"></a><a class="code" href="group__Scene.html#gaf8d481b975f32411b1212efd00deda5e">00187</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#gaf8d481b975f32411b1212efd00deda5e" title="Returns true if this technique supports skeletal animation.">_supportsSkeletalAnimation</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTechnSupportsSkeletal; }
<a name="l00188"></a>00188 
<a name="l00190"></a>00190         <span class="keywordtype">void</span> _updateBounds(<span class="keywordtype">void</span>);
<a name="l00191"></a>00191 
<a name="l00202"></a>00202         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> calculateMaxNumInstances( <span class="keyword">const</span> <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a> *baseSubMesh, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> flags ) <span class="keyword">const</span> = 0;
<a name="l00203"></a>00203 
<a name="l00217"></a>00217         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a> build( <span class="keyword">const</span> <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* baseSubMesh );
<a name="l00218"></a>00218 
<a name="l00231"></a>00231         <span class="keyword">virtual</span> <span class="keywordtype">void</span> buildFrom( <span class="keyword">const</span> <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a> *baseSubMesh, <span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a> &amp;renderOperation );
<a name="l00232"></a>00232 
<a name="l00233"></a><a class="code" href="group__Scene.html#gaa6c83f6d76357d471b84ffcd99192b79">00233</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">Ogre::MeshPtr</a>&amp; <a class="code" href="group__Scene.html#gaa6c83f6d76357d471b84ffcd99192b79">_getMeshReference</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMeshReference; }
<a name="l00234"></a>00234 
<a name="l00238"></a><a class="code" href="group__Scene.html#gab49772ceffccf524a8d2855267efe4a6">00238</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#gab49772ceffccf524a8d2855267efe4a6">isBatchFull</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUnusedEntities.empty(); }
<a name="l00239"></a>00239 
<a name="l00242"></a><a class="code" href="group__Scene.html#ga9dcabc18be7c515324929abe640e4df4">00242</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#ga9dcabc18be7c515324929abe640e4df4" title="Returns true if it no instanced entity has been requested or all of them have been removed...">isBatchUnused</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUnusedEntities.size() == mInstancedEntities.size(); }
<a name="l00243"></a>00243 
<a name="l00247"></a>00247         <span class="keywordtype">void</span> getInstancedEntitiesInUse( InstancedEntityVec &amp;outEntities );
<a name="l00248"></a>00248 
<a name="l00260"></a>00260         <span class="keywordtype">void</span> _defragmentBatch( <span class="keywordtype">bool</span> optimizeCulling, InstancedEntityVec &amp;usedEntities );
<a name="l00261"></a>00261 
<a name="l00267"></a>00267         <span class="keywordtype">void</span> _defragmentBatchDiscard(<span class="keywordtype">void</span>);
<a name="l00268"></a>00268 
<a name="l00272"></a>00272         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _boundsDirty(<span class="keywordtype">void</span>);
<a name="l00273"></a>00273 
<a name="l00287"></a><a class="code" href="group__Scene.html#gaae254079f412672ce137dddb9736028a">00287</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="group__Scene.html#gaae254079f412672ce137dddb9736028a" title="Tells this batch to stop updating animations, positions, rotations, and display all it&#39;s active insta...">setStaticAndUpdate</a>( <span class="keywordtype">bool</span> bStatic )     {}
<a name="l00288"></a>00288 
<a name="l00291"></a><a class="code" href="group__Scene.html#gabd6aa7ef499a88ecae701850d20da323">00291</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#gabd6aa7ef499a88ecae701850d20da323" title="Returns true if this batch was set as static.">isStatic</a>()<span class="keyword"> const                       </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00292"></a>00292 
<a name="l00299"></a>00299         <a class="code" href="classOgre_1_1InstancedEntity.html">InstancedEntity</a>* createInstancedEntity();
<a name="l00300"></a>00300 
<a name="l00307"></a>00307         <span class="keywordtype">void</span> removeInstancedEntity( <a class="code" href="classOgre_1_1InstancedEntity.html">InstancedEntity</a> *instancedEntity );
<a name="l00308"></a>00308 
<a name="l00312"></a><a class="code" href="group__Scene.html#ga2dfd51444863b83c51524755ce370c06">00312</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#ga2dfd51444863b83c51524755ce370c06" title="Tells whether world bone matrices need to be calculated.">useBoneWorldMatrices</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00313"></a>00313 
<a name="l00315"></a><a class="code" href="group__Scene.html#ga2773601083f5a3d41dd071aec04fd5d8">00315</a>         <span class="keywordtype">void</span> <a class="code" href="group__Scene.html#ga2773601083f5a3d41dd071aec04fd5d8" title="Tells that the list of entity instances with shared transforms has changed.">_markTransformSharingDirty</a>() { mTransformSharingDirty = <span class="keyword">true</span>; }
<a name="l00316"></a>00316 
<a name="l00317"></a>00317         <span class="comment">//Renderable overloads</span>
<a name="l00319"></a><a class="code" href="group__Scene.html#gab5a57df175de5461bf23b384831493c3">00319</a> <span class="comment"></span>        <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; <a class="code" href="group__Scene.html#gab5a57df175de5461bf23b384831493c3">getMaterial</a>(<span class="keywordtype">void</span>)<span class="keyword"> const      </span>{ <span class="keywordflow">return</span> mMaterial; }
<a name="l00321"></a><a class="code" href="group__Scene.html#gadcb91b7c109b3b4b74504b7dd5f7a13d">00321</a>         <span class="keywordtype">void</span> <a class="code" href="group__Scene.html#gadcb91b7c109b3b4b74504b7dd5f7a13d">getRenderOperation</a>( <a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>&amp; op )  { op = mRenderOperation; }
<a name="l00322"></a>00322 
<a name="l00324"></a>00324         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getSquaredViewDepth( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam ) <span class="keyword">const</span>;
<a name="l00326"></a>00326         <span class="keyword">const</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a>&amp; getLights( <span class="keywordtype">void</span> ) <span class="keyword">const</span>;
<a name="l00328"></a>00328         <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* getTechnique(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00329"></a>00329 
<a name="l00331"></a>00331         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getMovableType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00333"></a>00333         <span class="keywordtype">void</span> _notifyCurrentCamera( <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam );
<a name="l00335"></a>00335         <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getBoundingBox(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00337"></a>00337         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getBoundingRadius(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00338"></a>00338 
<a name="l00339"></a>00339         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateRenderQueue(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue);
<a name="l00340"></a>00340         <span class="keywordtype">void</span> visitRenderables( <a class="code" href="classOgre_1_1Renderable_1_1Visitor.html" title="Visitor object that can be used to iterate over a collection of Renderable instances abstractly...">Renderable::Visitor</a>* visitor, <span class="keywordtype">bool</span> debugRenderables = <span class="keyword">false</span> );
<a name="l00341"></a>00341     };
<a name="l00342"></a>00342 }
<a name="l00343"></a>00343 
<a name="l00344"></a>00344 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
